<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class TransferioValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		
		if(empty($input["toKapalId"])){
			array_push($this->error, ["toKapalId" => "cannot be null"]);
		}
		else{
			$lengthtokapalid = strlen($input["toKapalId"]);
			if($lengthtokapalid>19){
			array_push($this->error, ["tokapalid" => "value too long"]);
			}
		}
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["toKapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["toKapalId" => "invalid relation"]);
		}
		
		if(empty($input["type"])){
			array_push($this->error, ["type" => "cannot be null"]);
		}
		else{
			$lengthtype = strlen($input["type"]);
			if($lengthtype>3){
			array_push($this->error, ["type" => "value too long"]);
			}
		}
        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["fromKapalId"])){
			array_push($this->error, ["fromKapalId" => "cannot be null"]);
		}
		else{
			$lengthfromkapalid = strlen($input["fromKapalId"]);
			if($lengthfromkapalid>19){
			array_push($this->error, ["fromkapalid" => "value too long"]);
			}
		}
		if(!empty($input["fromKapalId"])){
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["fromKapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["fromKapalId" => "invalid relation"]);
		}
		}
		if(empty($input["toKapalId"])){
			array_push($this->error, ["toKapalId" => "cannot be null"]);
		}
		else{
			$lengthtokapalid = strlen($input["toKapalId"]);
			if($lengthtokapalid>19){
			array_push($this->error, ["tokapalid" => "value too long"]);
			}
		}
		if(!empty($input["toKapalId"])){
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["toKapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["toKapalId" => "invalid relation"]);
		}
		}
		if(empty($input["fromLocationId"])){
			array_push($this->error, ["fromLocationId" => "cannot be null"]);
		}
		else{
			$lengthfromlocationid = strlen($input["fromLocationId"]);
			if($lengthfromlocationid>19){
			array_push($this->error, ["fromlocationid" => "value too long"]);
			}
		}
		if(!empty($input["fromLocationId"])){
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["fromLocationId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["fromLocationId" => "invalid relation"]);
		}
		}
		if(empty($input["toLocationId"])){
			array_push($this->error, ["toLocationId" => "cannot be null"]);
		}
		else{
			$lengthtolocationid = strlen($input["toLocationId"]);
			if($lengthtolocationid>19){
			array_push($this->error, ["tolocationid" => "value too long"]);
			}
		}
		if(!empty($input["toLocationId"])){
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["toLocationId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["toLocationId" => "invalid relation"]);
		}
		}
		if(empty($input["requesterId"])){
			array_push($this->error, ["requesterId" => "cannot be null"]);
		}
		else{
			$lengthrequesterid = strlen($input["requesterId"]);
			if($lengthrequesterid>19){
			array_push($this->error, ["requesterid" => "value too long"]);
			}
		}
		if(!empty($input["requesterId"])){
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["requesterId"])->first();
		if(empty($users)){
			array_push($this->error, ["requesterId" => "invalid relation"]);
		}
		}
		if(empty($input["type"])){
			array_push($this->error, ["type" => "cannot be null"]);
		}
		else{
			$lengthtype = strlen($input["type"]);
			if($lengthtype>3){
			array_push($this->error, ["type" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

	}
	


	public function beforeApprove($input){
		if(empty($input["approverId"])){
			array_push($this->error, ["approverId" => "cannot be null"]);
		}
		else{
			$lengthapproverid = strlen($input["approverId"]);
			if($lengthapproverid > 19){
			array_push($this->error, ["approverid" => "value too long"]);
			}
		}
		if(!empty($input["approverId"])){
			$users= (new \App\Http\Models\UsersModel())
				->getQuery()->where("id","=",$input["approverId"])->first();
			if(empty($users)){
				array_push($this->error, ["approverId" => "invalid relation"]);
			}
		}
		if(empty($input["ioNumber"])){
			array_push($this->error, ["ioNumber" => "IO Number is not set"]);
		}

        return $this;
    }


}